{ Copyright (C) 09/09/2004 00:00, Luis R. Hilario B. <info@luisdigital.com>

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}

unit facturar;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, LResources, Buttons,
  ExtCtrls, ComCtrls,
  util, klintonstrconst, TxtDB, factura;

type
  TForm8 = class(TForm)
    Bitbtn1: TBITBTN;
    BitbtnNuevo: TBITBTN;
    BitbtnModificar: TBITBTN;
    BitbtnEliminar: TBITBTN;
    BitbtnAyuda: TBITBTN;
    Listview1: TLISTVIEW;
    Notebook1: TNOTEBOOK;
    Page1: TPAGE;
    Shape1: TSHAPE;
    procedure BitbtnEliminarCLICK(Sender: TObject);
    procedure BitbtnModificarCLICK(Sender: TObject);
    procedure BitbtnNuevoCLICK(Sender: TObject);
    procedure Form8CREATE(Sender: TObject);
    procedure Form8SHOW(Sender: TObject);
  private
    { private declarations }
    procedure UpdateListView1;
  public
    { public declarations }
  end; 

var
  Form8: TForm8;
  TXTDBFactura,
  TXTDBClientes: TTXTDB;

implementation

{ TForm8 }

procedure TForm8.UpdateListView1;
var
  Index: Integer;
  Iteme: TListItem;

begin
  TXTDBClientes := TTXTDB.create(ArchivoTXTDBClientes);
  TXTDBClientes.ReadTXTDB;
  TXTDBFactura := TTXTDB.create(ArchivoTXTDBFactura);
  With TXTDBFactura do
  begin
   ReadTXTDB;
   Listview1.Items.Clear;
   for Index := 1 to RecordCount do
   begin
     Iteme := Listview1.Items.Add;
     RecordIndex := Index;
     Iteme.Caption := RecordData[fnNRO_FACT];
     Iteme.SubItems.Add(RecordData[fnFECHA_FACT]);
     if TXTDBClientes.DataExist(fnCODIGO, RecordData[fnCOMPRADOR]) then
       Iteme.SubItems.Add(TXTDBClientes.RecordData[fnNOMBRE]) else
       Iteme.SubItems.Add('---');
     Iteme.SubItems.Add(RecordData[fnVENDEDOR]);
     Iteme.SubItems.Add(RecordData[fnTIPO_PAGO]);
     Iteme.SubItems.Add(RecordData[fnTOTAL]);
   end;
   Free;
  end;
  TXTDBClientes.Free;
end;

procedure TForm8.Form8CREATE(Sender: TObject);
begin
  BitbtnNuevo.Caption := rsNuevo;
  BitbtnNuevo.Glyph := CargarRecImag('factn');
  BitbtnModificar.Caption := rsModificar;
  BitbtnModificar.Glyph := CargarRecImag('factm');
  BitbtnEliminar.Caption := rsEliminar;
  BitbtnEliminar.Glyph := CargarRecImag('facte');
end;

procedure TForm8.Form8SHOW(Sender: TObject);
begin
  UpdateListView1;
end;

procedure TForm8.BitbtnNuevoCLICK(Sender: TObject);
begin
  Form9.Caption := BitbtnNuevo.Caption;
  if Form9.ShowModal = mrOk then
   begin
    UpdateListView1
   end;
end;

procedure TForm8.BitbtnEliminarCLICK(Sender: TObject);
var
  NF: String;
  RecordDeleted: Boolean;

begin
  if ListView1.Selected = nil then MSGInfo(rsNoSelected)
  else
    if MSGConfirmationYN(rsDeleteReg) = mrYes then
    begin
      TXTDBFactura := TTXTDB.create(ArchivoTXTDBFactura);
      TXTDBFactura.ReadTXTDB;
      TXTDBFactura.RecordIndex := ListView1.Selected.Index +1;
      NF := TXTDBFactura.RecordData[fnNRO_FACT];
      RecordDeleted := TXTDBFactura.RecordDelete;
      TXTDBFactura.Free;
      if RecordDeleted then
      begin
       TXTDBItems := TTXTDB.create(ArchivoTXTDBItems);
       With TXTDBItems do
        begin
          ReadTXTDB;
          if DataExist(fnNRO_FACT, NF) then
           repeat
            if Not RecordDelete then MSGError(rsNoDeleted);
           until  (RecordIndex > RecordCount) Or
                  (RecordData[fnNRO_FACT] <> NF);
        end;
       UpdateListView1;
      end else MSGError(rsNoDeleted);
    end;
end;

procedure TForm8.BitbtnModificarCLICK(Sender: TObject);
begin
  if ListView1.Selected = nil then MSGInfo(rsNoSelected)
  else
  begin
    Form9.Caption := BitbtnModificar.Caption;
    Form9.Tag := ListView1.Selected.Index +1;
    if Form9.ShowModal = mrOk then
     begin
      UpdateListView1
     end;
  end;
end;

initialization
  { $I facturar.lrs}
  {$I pics/botones.lrs}

end.

