{ Copyright (C) 09/09/2004 00:00, Luis R. Hilario B. <info@luisdigital.com>

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}

unit configuraciones;

{$IFDEF FPC}
 {$mode objfpc}
{$ENDIF}
{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  {$IFDEF FPC}LResources,{$ENDIF}
  StdCtrls, ExtCtrls, ComCtrls, Buttons,
  klintonstrconst, util, TxtDB,
{$IFDEF FPC}
  Process, Linux, ComCtrls;
{$ELSE}
  Windows;
{$ENDIF}

type
  TForm3 = class(TForm)
    Bitbtn1: TBITBTN;
    BitbtnCerrar: TBITBTN;
    Bitbtn3: TBITBTN;
    Opendialog1: TOPENDIALOG;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    GroupBox3: TGroupBox;
    Bevel2: TBevel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    BitBtnLogo: TBitBtn;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    GroupBox4: TGroupBox;
    Label24: TLabel;
    EditNavegador: TEdit;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    EditParametros: TEdit;
    Image1: TImage;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label28: TLabel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    Shape1: TShape;
    procedure Bitbtn3CLICK(Sender: TObject);
    procedure BitbtnLogoCLICK(Sender: TObject);
    procedure Button1CLICK(Sender: TObject);
    procedure Button2CLICK(Sender: TObject);
    procedure Button3CLICK(Sender: TObject);
    procedure Checkbox2CLICK(Sender: TObject);
    procedure Form3CLOSEQUERY(Sender: TObject; var CanClose: boolean);
    procedure Form3CREATE(Sender: TObject);
    procedure Form3SHOW(Sender: TObject);
    procedure Statictext2CLICK(Sender: TObject);
  private
    { private declarations }
     FLogoNombre: String;
  public
    { public declarations }
  end;
  
var
  Form3: TForm3; 

implementation

uses principal;

{ TForm3 }

procedure TForm3.Form3SHOW(Sender: TObject);
begin
  With TTXTDB.create(ArchivoTXTDBConf) do
  begin
   ReadTXTDB;
   Edit6.Text := RecordData[fnNOMBRE];
   Edit5.Text := RecordData[fnSLOGAN];
   Edit4.Text := RecordData[fnDIR1];
   Edit3.Text := RecordData[fnCIUDAD];
   Edit2.Text := RecordData[fnTEL];
   Edit1.Text := RecordData[fnEMAIL];
   FLogoNombre := RecordData[fnLOGO];
   Checkbox1.Checked := Boolean(RecordDataI[fnPNOMBRE]);
   Checkbox2.Checked := Boolean(RecordDataI[fnPSLOGAN]);
   Checkbox3.Checked := Boolean(RecordDataI[fnPDIR1]);
   Checkbox4.Checked := Boolean(RecordDataI[fnPCIUDAD]);
   Checkbox5.Checked := Boolean(RecordDataI[fnPTEL]);
   Checkbox6.Checked := Boolean(RecordDataI[fnPEMAIL]);
   Checkbox7.Checked := Boolean(RecordDataI[fnPLOGO]);
   Checkbox2CLICK(nil);
   EditNavegador.Text := RecordData[fnNAVEGADOR]; //Browser
   EditParametros.Text := RecordData[fnPARAMETROS];
   Free;
  end;

  BitbtnLogo.Glyph.LoadFromFile(FLogoNombre);

  if EditNavegador.Text = cPredeterminado then
  begin
    EditNavegador.Enabled := False;
    EditParametros.Enabled := False;
  end else
  begin
    EditNavegador.Enabled := True;
    EditParametros.Enabled := True;
  end;
end;

procedure TForm3.Statictext2CLICK(Sender: TObject);
begin
   Button3CLICK(Sender);
end;

procedure TForm3.BitbtnLogoCLICK(Sender: TObject);
begin
  Opendialog1.Filter := 'Archivos Grficos (*'+ImagesExt+')|*'+ImagesExt;
  Opendialog1.Title := 'Seleccione un archivo.';
  {$IFDEF FPC}
  if Opendialog1.Execute then
    if AnsiUpperCase(ExtractFileExt(Opendialog1.FileName)) = '.XPM' Then
     begin
      FLogoNombre := Opendialog1.FileName;
      BitbtnLogo.Glyph := CargarArcImag(FLogoNombre);
     end;
{$ELSE}
  if Opendialog1.Execute then
    if AnsiLowerCase(ExtractFileExt(Opendialog1.FileName)) = ImagesExt Then
     begin
      FLogoNombre := Opendialog1.FileName;
      BitbtnLogo.Glyph.LoadFromFile(FLogoNombre);
     end;
{$ENDIF}
end;

procedure TForm3.Bitbtn3CLICK(Sender: TObject);
begin
  AyudaHTML(Con_Conf);
end;

procedure TForm3.Button1CLICK(Sender: TObject);
begin
{$IFDEF FPC}
    EditNavegador.Text := SystemBrowser('FullPath');
    EditParametros.Text := SystemBrowser('Para');
{$ELSE}
    EditNavegador.Text := cPredeterminado;
    EditParametros.Text := '';
    EditNavegador.Enabled := False;
    EditParametros.Enabled := False;
{$ENDIF}
end;

procedure TForm3.Button2CLICK(Sender: TObject);
begin
  Opendialog1.Title := 'Seleccione un Navegador Web.';
  Opendialog1.Filter := '';
  if Opendialog1.Execute then
  begin
    EditNavegador.Enabled := True;
    EditParametros.Enabled := True;
    EditNavegador.Text := Opendialog1.FileName;
    EditParametros.Text := '';
  end;
  ProgramReset;
end;

procedure TForm3.Button3CLICK(Sender: TObject);
begin
{$IFDEF FPC}
  if FileExists(EditNavegador.Text) then
  begin
   if Linux.Access(EditNavegador.Text, Linux.X_OK) then
   begin
    //Process1.ApplicationName := EditNavegador.Text + ' '+ EditParametros.Text;
    Process1.CommandLine := EditNavegador.Text + ' '+ EditParametros.Text +' '+
                            Statictext1.Caption;
    Process1.Execute;
   end;
  end;
{$ELSE}
  if EditNavegador.Text = cPredeterminado then
    ExecuteFile(Statictext2.Caption, '')
  else
    ExecuteFile(EditNavegador.Text, EditParametros.Text +' '+
                Statictext2.Caption);
{$ENDIF}
end;

procedure TForm3.Checkbox2CLICK(Sender: TObject);
begin
  if Checkbox1.Checked then Checkbox1.Caption := rsSI else
                            Checkbox1.Caption := rsNO;
  if Checkbox2.Checked then Checkbox2.Caption := rsSI else
                            Checkbox2.Caption := rsNO;
  if Checkbox3.Checked then Checkbox3.Caption := rsSI else
                            Checkbox3.Caption := rsNO;
  if Checkbox4.Checked then Checkbox4.Caption := rsSI else
                            Checkbox4.Caption := rsNO;
  if Checkbox5.Checked then Checkbox5.Caption := rsSI else
                            Checkbox5.Caption := rsNO;
  if Checkbox6.Checked then Checkbox6.Caption := rsSI else
                            Checkbox6.Caption := rsNO;
  if Checkbox7.Checked then Checkbox7.Caption := rsSI else
                            Checkbox7.Caption := rsNO;
end;

procedure TForm3.Form3CLOSEQUERY(Sender: TObject; var CanClose: boolean);
begin
  ProgramReset;
  if ModalResult = mrOK then
    begin
      With TTXTDB.create(ArchivoTXTDBConf) do
      begin
       ReadTXTDB;
       RecordData[fnNOMBRE] := Edit6.Text;
       RecordData[fnSLOGAN] := Edit5.Text;
       RecordData[fnDIR1] := Edit4.Text;
       RecordData[fnCIUDAD] := Edit3.Text;
       RecordData[fnTEL] := Edit2.Text;
       RecordData[fnEMAIL] := Edit1.Text;
       RecordData[fnLOGO] := FLogoNombre;
       RecordDataI[fnPNOMBRE] := Integer(Checkbox1.Checked);
       RecordDataI[fnPSLOGAN] := Integer(Checkbox2.Checked);
       RecordDataI[fnPDIR1] := Integer(Checkbox3.Checked);
       RecordDataI[fnPCIUDAD] := Integer(Checkbox4.Checked);
       RecordDataI[fnPTEL] := Integer(Checkbox5.Checked);
       RecordDataI[fnPEMAIL] := Integer(Checkbox6.Checked);
       RecordDataI[fnPLOGO] := Integer(Checkbox7.Checked);
       RecordData[fnNAVEGADOR] := EditNavegador.Text; //Browser
       RecordData[fnPARAMETROS] := EditParametros.Text;
       WriteTXTDB;
       Free;
      end;
    end;
end;

procedure TForm3.Form3CREATE(Sender: TObject);
begin
  Image1.Picture := Form1.Image1.Picture;
  Label11.Caption := rsVersion;
  Label12.Caption := rsSerie;
  Label13.Caption := rsDerechos;
  Label22.Caption := rsImprimir;
  Label24.Caption := rsParametros+Label24.Caption;
  Bitbtn1.Caption := rsAAceptar;
  Bitbtn3.Caption := rsAAyuda;
  BitbtnCerrar.Caption := rsACerrar;
  Button4.Caption := rsPredeterminado;
end;

initialization
{$IFDEF FPC}
  {$I configuraciones.lrs}
{$ELSE}
  {$R *.dfm}
{$ENDIF}

end.

