{ Copyright (C) 09/09/2004 00:00, Luis R. Hilario B. <info@luisdigital.com>

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}

unit klintonstrconst;

{$IFDEF FPC}
 {$mode objfpc}
{$ENDIF}
{$H+}

interface

uses
  Classes, SysUtils;

const
  ArchivoConfiguracion = 'klinton.txt';
  ArchivoTXTDBClientes = 'clientes.txt';
  ArchivoTXTDBInventario = 'inventario.txt';
  ArchivoTXTDBCategoria = 'categoria.txt';
  ArchivoTXTDBFactura = 'factura.txt';
  ArchivoTXTDBItems = 'items.txt';
  ArchivoTXTDBConf = 'conf.txt';
  ArchivoAyuda = 'ayuda/ayuda.html';
  ImageUbi = 'ubi';
{$IFDEF FPC}
  ImagesExt = '.xpm';
  ImagesDir = 'images/';
  Plantillas = 'plantillas/factura.html';
  Plantillas_Salida = 'temp/print_factura.html';
{$ELSE}
  ImagesExt = '.bmp';
  ImagesDir = 'images\';
  Plantillas = 'plantillas\factura.html';
  Plantillas_Salida = 'temp\print_factura.html';
{$ENDIF}


// ConTexto
  Con_Conf = '#3.1._La_ventana_de_configuraciones';
  Con_Opc = '#4._Opciones_basicas';
  Con_CrearC = '#5._Creando_un_cliente_o_proveedor_nuevo';
  Con_CrearP = '#6._Creando_un_producto_nuevo';
  Con_CrearF = '#7._Creando_una_factura';

// Others
  SubTotal = 'SubTotal';
  cCODE = 'CODE';
  cSaldo = 'Saldo';
  cPredeterminado = '{Predeterminado}';

// Nombres de campos
// -----------------

// Generico
  fnCODIGO = 'CODIGO';
  
// clientes.txt
  fnNOMBRE = 'NOMBRE';
  fnCATEGORIA = 'CATEGORIA';
  fnSUBC = 'SUBC';
  fnDIR1 = 'DIR1';  // Usados en otras tablas C60
  fnDIR2 = 'DIR2';
  fnCIUDAD = 'CIUDAD';
  fnESTADO = 'ESTADO';
  fnZIP = 'ZIP';
  fnPAIS = 'PAIS';
  fnCONTACTO = 'CONTACTO';
  fnTEL = 'TEL';
  fnFAX = 'FAX';
  fnRT = 'RT';
  fnEMAIL = 'EMAIL';
  fnNOTA1 = 'NOTA1';
  fnNOTA2 = 'NOTA2';
  fnNOTA3 = 'NOTA3';
  fnFECHAC = 'FECHAC';

// inventario.txt
  fnDESC = 'DESC'; //C60
  fnPRECIO1 = 'PRECIO1'; //N17
  fnPRECIO2 = 'PRECIO2';
  fnCOSTO = 'COSTO';
  fnCANT_ALM = 'CANT_ALM';
  fnCANT_MINI = 'CANT_MINI';
  fnPROVEEDOR1 = 'PROVEEDOR1'; //C14
  fnPROVEEDOR2 = 'PROVEEDOR2';
  fnPROVEEDOR3 = 'PROVEEDOR3';
  fnCOMENTARIO1 = 'COMENTARIO1'; //C30
  fnCOMENTARIO2 = 'COMENTARIO2';
  fnCOMENTARIO3 = 'COMENTARIO3';
  fnCOD_CATEG = 'COD_CATEG'; //C14
  fnIMAGEN = 'IMAGEN'; //C20
  fnPROD_TIPO = 'PROD_TIPO'; //N1
  fnFACT_SIN_EX = 'FACT_SIN_EX';
  fnINCREMENTO1 = 'INCREMENTO1'; //N6
  fnINCREMENTO2 = 'INCREMENTO2';
  fnCOD_FAB = 'COD_FAB'; //C24
  fnUBICACION = 'UBICACION'; //C20
  fnUBI1_X = 'UBI1_X'; //N3
  fnUBI1_Y = 'UBI1_Y';
  fnUBI2_X = 'UBI2_X';
  fnUBI2_Y = 'UBI2_Y';
  fnUBI3_X = 'UBI3_X';
  fnUBI3_Y = 'UBI3_Y';
  fnF_EXP = 'F_EXP'; //C10
  fnAVISAR_F_E = 'AVISAR_F_E'; //N1
  fnULT_VEN = 'ULT_VEN'; //C10

// Categoria
  fnPRODUCTO = 'PRODUCTO'; //C14

// Factura
  fnNRO_FACT = 'NRO_FACT'; //N8
  fnCOMPRADOR = 'COMPRADOR'; //C14
  fnENVIADO_A1 = 'ENVIADO_A1'; //C60 (DIR1)
  fnENVIADO_A2 = 'ENVIADO_A2';
  fnENVIAR_POR = 'ENVIAR_POR'; //C12
  fnTIPO_PAGO = 'TIPO_PAGO';
  fnVENDEDOR = 'VENDEDOR'; //C5
  fnFECHA_FACT = 'FECHA_FACT'; //C10
  fnFECHA_VENC = 'FECHA_VENC';
  fnCOMENTA1 = 'COMENTA1'; //C30
  fnCOMENTA2 = 'COMENTA2';
  fnCOMENTA3 = 'COMENTA3';
  fnOTROS = 'OTROS'; //N17
  fnDESCUENTO = 'DESCUENTO'; //N13
  fnIMPUESTO = 'IMPUESTO';
  fnTOTAL = 'TOTAL'; //N17
  fnCAJA_PAGO = 'CAJA_PAGO';

// Items
  //NRO_FACT-N8
  fnITEM = 'ITEM'; //C14
  //DESC-C60
  fnCANTIDAD = 'CANTIDAD'; //N9
  fnPRECIO = 'PRECIO'; //N17
  //COSTO-N17

// Conf
  //fnNOMBRE = 'NOMBRE'; //C60
  fnSLOGAN = 'SLOGAN'; //C30
  //fnDIR1 = 'DIR1'; //C40
  //fnCIUDAD = 'CIUDAD'; //C40
  //fnTEL = 'TEL'; //C40
  //fnEMAIL = 'EMAIL'; //C60
  fnLOGO = 'LOGO'; //C73
  fnPNOMBRE = 'PNOMBRE'; //N1
  fnPSLOGAN = 'PSLOGAN'; //N1
  fnPDIR1 = 'PDIR1'; //N1
  fnPCIUDAD = 'PCIUDAD'; //N1
  fnPTEL = 'PTEL'; //N1
  fnPEMAIL = 'PEMAIL'; //N1
  fnPLOGO = 'PLOGO'; //N1
  fnNAVEGADOR = 'NAVEGADOR'; //C60
  fnPARAMETROS = 'PARAMETROS'; //C99

resourcestring

// Ventana principal: Form1
  rsVersion = 'Versin: 1.0';
  rsSerie = 'Nro. de serie: 06102005-GNU/(L)GPL';
  rsDerechos = 'Copyright  2004-2005 Luis Digital. Todos los derechos reservados.';

// Ventana Configuraciones: Form3
  rsNOMBRE = 'NOMBRE';
  rsSLOGAN = 'SLOGAN';
  rsDIRECCION = 'DIRECCION';
  rsCIUDAD = 'CIUDAD';
  rsTelFax = 'Tel./Fax.';
  rsWebEMail = 'Web/EMail';
  rsImprimir = 'Imprimir';
  rsParametros = 'Parmetros';
  rsPredeterminado = 'Predeterminado';

// Ventana bsico (importante pare el control de las funciones)
  rsNuevo = 'Nuevo';
  rsModificar = 'Modificar';
  rsVer = 'Ver';

// Ventana Aadir: Form5
  rsAnadir = 'Aadir';
  rsInformacion = 'Informacin';
  rsConfirmacion = 'Confirmacin';
  rsAdvertencia = 'Advertencia';

// Ventana Aadir: Form7
  rsAvisarEx = 'Avisar expiracin';
  rsFactEx = 'Facturar sin existencia';
  rsDirVacio = 'Directorio de imgenes vaco.';

// Ventana Factura: Forma9
  rsNFactura = 'Nmero Factura';
  rsFecha = 'Fecha';
  rsEnviar = 'Enviar por';
  rsPago = 'Tipo Pago';
  rsVend = 'Vendedor:';
  rsComprador = 'Comprador:';
  rsEnviar_a = 'Enviar a:';
  rsComentario = 'Comentario:';
  rsVerProd = 'Ver Prod. F3';
  rsListaProd = 'Lista Prod. F4';
  rsInsertarFila = 'Ins. Fila F5';
  rsEliminarFila = 'Eli. Fila F6';
  rsSubTotal = 'Sub-Total';
  rsOtros = 'Otros:';
  rsDesc = 'Descuento:';
  rsImp = 'Impuesto:';
  rsTOTAL = 'TOTAL';
  rsPagado = '-Pagado:';
  rsSaldo = 'Saldo:';
  rsVence = 'Vence:';
// ComboboxP Tipo de Pago
  rsEfectivo = 'Efectivo';
  rsCredito = 'Crdito';
  rsOtro = 'Otro';

// Mensajes
  rsNoDeleted = 'No se puede eliminar el registro.';
  rsDeleteReg = 'Est seguro que desea borrar el registro?';
  rsExist = 'Ya existe: ';
  rsAnadido = 'Aadido.';
  rsNoSelected = 'Primero seleccione un registro.';
  rsInvalidDate = 'Fecha Invalida.';
  rsProMini = 'Producto con poca existencia, disponible: ';
  rsNoExist = 'Producto sin Existencia!';
  rsExp1 = 'Producto Expir: ';
  rsExp2 = #10 + 'Desea incluirlo?';
  rsCode = 'Cdigo: ';
  rsInvalidCode = 'Cdigo Invalido.';

// Varios
  rsSI = 'S';
  rsNO = 'No';
  rsSelection = 'Seleccione';
  rsFisico = 'Fsico';
  rsServicio = 'Servicio';
  rsProveedor = 'Proveedor';
  rsCliente = 'Cliente';
  rsInsertar = 'Insertar';
  rsInventario = 'Inventario';
// Atajos
  rsAAceptar = '&Aceptar';
  rsACerrar = '&Cerrar';
  rsAAyuda = 'Ay&uda';
  rsANuevo = '&Nuevo';
  rsAModificar = '&Modificar';
  rsAVer = '&Ver';
  rsAInsertar = '&Insertar';
  rsAEliminar = '&Eliminar';
  rsAGuardar = '&Guardar';
  rsAGI = 'Guardar-&Imprimir';

const
  ProdTipo: array [0..1] of string = (rsFisico, rsServicio);

  MaxPagoTipo = 2;
  PagoTipo: array [0..MaxPagoTipo] of string =
    (rsEfectivo, rsCredito, rsOtro);

implementation

end.

