{ Copyright (C) 09/09/2004 00:00, Luis R. Hilario B. <info@luisdigital.com>

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}

unit productos;

{$IFDEF FPC}
 {$mode objfpc}
{$ENDIF}
{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  {$IFDEF FPC}
  LResources, LCLType,
  {$ENDIF}
  ComCtrls, Buttons, ExtCtrls, StdCtrls,
  Util, KlintonStrConst, TXTDB;

type
  TForm7 = class(TForm)
    Bitbtn1: TBITBTN;
    Bitbtn2: TBITBTN;
    Bitbtn3: TBITBTN;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    EditCodigo: TEdit;
    Label2: TLabel;
    EditDesc: TEdit;
    Label4: TLabel;
    Groupbox1: TGroupBox;
    Listbox1: TListBox;
    Panel3: TPanel;
    Image1: TImage;
    Groupbox4: TGroupBox;
    Panel4: TPanel;
    Image2: TImage;
    EditUbi: TEdit;
    Groupbox3: TGroupBox;
    Combobox1: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Groupbox5: TGroupBox;
    LabelNP1: TLabel;
    LabelNP2: TLabel;
    LabelNP3: TLabel;
    Combobox2: TComboBox;
    Combobox3: TComboBox;
    Combobox4: TComboBox;
    Groupbox2: TGroupBox;
    EditC1: TEdit;
    EditC2: TEdit;
    EditC3: TEdit;
    Label3: TLabel;
    EditCosto: TEdit;
    Statictext1: TStaticText;
    EditUtil1: TEdit;
    EditUtil2: TEdit;
    Statictext2: TStaticText;
    Label5: TLabel;
    Label7: TLabel;
    EditPrecio1: TEdit;
    EditPrecio2: TEdit;
    Label6: TLabel;
    EditCod_Fab: TEdit;
    Radiogroup1: TRadioGroup;
    Panel2: TPanel;
    Edit10: TEdit;
    Edit11: TEdit;
    Panel1: TPanel;
    EditFE: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    PaintBox1: TPaintBox;
    procedure Bitbtn1CLICK(Sender: TObject);
    procedure Button1CLICK(Sender: TObject);
    procedure Button2CLICK(Sender: TObject);
    procedure Combobox2CHANGE(Sender: TObject);
    procedure Edit10CHANGE(Sender: TObject);
    procedure Edit11CHANGE(Sender: TObject);
    procedure EditCodigoEXIT(Sender: TObject);
    procedure EditCodigoKEYPRESS(Sender: TObject; var Key: Char);
    procedure EditCostoCHANGE(Sender: TObject);
    procedure EditFEEXIT(Sender: TObject);
    procedure EditPrecio1CHANGE(Sender: TObject);
    procedure EditPrecio2CHANGE(Sender: TObject);
    procedure EditUtil1CHANGE(Sender: TObject);
    procedure EditUtil2CHANGE(Sender: TObject);
    procedure Form7CREATE(Sender: TObject);
    procedure Form7SHOW(Sender: TObject);
    procedure Listbox1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Bitbtn3Click(Sender: TObject);
  private
    { private declarations }
    procedure UpDateImage1;
    procedure UpdateLabelNP(Number: Byte);
    procedure PutIndicator(Const X, Y: Integer);
    procedure ReDrawPoints;
    procedure EnabledControls(Enableds: Boolean);
  public
    { public declarations }
  end; 

var
  Form7: TForm7;
  TXTDBCategoria,
  TXTDBClientes,
  TXTDBInventario: TTXTDB;

implementation

{ TForm7 }

Type
  Point = record
    X, Y: Integer;
  end;

var
  Points: Array[1..3] of Point; //TPoint en Types o Windows
  PointCount: Byte;

procedure TForm7.UpdateImage1;
begin
  //Groupbox1.Enabled := True;
  if ListBox1.ItemIndex = 0 then Image1.Visible := False
  else
    begin
      Image1.Visible := True;
      Image1.Picture.LoadFromFile(ImagesDir+ListBox1.Items[ListBox1.ItemIndex]
                                  +ImagesExt);
    end;
  //Groupbox1.Enabled := Boolean(Groupbox1.Tag);
end;

procedure TForm7.UpdateLabelNP(Number: Byte);
var TXTDBProveedores: TTXTDB;

begin
  TXTDBProveedores := TTXTDB.create(ArchivoTXTDBClientes);
  With TXTDBProveedores do
  begin
    ReadTXTDB;

    Case Number of
     1: if DataExist(fnCODIGO, Combobox2.Text) then
          LabelNP1.Caption := RecordData[fnNOMBRE] else LabelNP1.Caption := '';
     2: if DataExist(fnCODIGO, Combobox3.Text) then
          LabelNP2.Caption := RecordData[fnNOMBRE] else LabelNP2.Caption := '';
     3: if DataExist(fnCODIGO, Combobox4.Text) then
          LabelNP3.Caption := RecordData[fnNOMBRE] else LabelNP3.Caption := '';
    end;
  Free;
  end;
end;

procedure TForm7.PutIndicator(Const X, Y: Integer);
begin
   With PaintBox1.Canvas do
   begin
     pen.Color := clYellow;
     brush.color := clRed;
     Rectangle(X,Y,X+4,Y+4);
   end;
end;

procedure TForm7.ReDrawPoints;
var Count: Byte;

begin
{$IFDEF FPC}
  Image2.Refresh;
{$ELSE}
  //PaintBox1.Color := Not PaintBox1.Color;
{$ENDIF}
  For Count := 1 to PointCount do
    PutIndicator(Points[Count].X, Points[Count].Y);
end;

procedure TForm7.EnabledControls(Enableds: Boolean);
begin
  EditDesc.Enabled := Enableds;
  EditCosto.Enabled := Enableds;
  EditUtil1.Enabled := Enableds;
  EditUtil2.Enabled := Enableds;
  EditPrecio1.Enabled := Enableds;
  EditPrecio2.Enabled := Enableds;
  Radiogroup1.Enabled := Enableds;
  EditCod_Fab.Enabled := Enableds;
  Panel1.Enabled := Enableds;
  Panel2.Enabled := Enableds;
  Groupbox1.Tag := Integer(Enableds);
  Groupbox1.Enabled := Enableds;
  Groupbox2.Enabled := Enableds;
  Groupbox3.Enabled := Enableds;
  Groupbox4.Enabled := Enableds;
  Groupbox5.Enabled := Enableds;
end;

procedure TForm7.Form7CREATE(Sender: TObject);
Var
 Info: TSearchRec;
 Index: Integer;
 
begin
  Bitbtn1.Caption := rsAAceptar;
  Bitbtn2.Caption := rsACerrar;
  Bitbtn3.Caption := rsAAyuda;
  CheckBox1.Caption := rsAvisarEx;
  CheckBox2.Caption := rsFactEx;
  If FindFirst(ImagesDir+'*'+ImagesExt, faArchive, Info)=0 then
  begin
    ListBox1.Items.Add(rsSelection);
    Repeat
      ListBox1.Items.Add(Copy(Info.Name, 1,
                              Length(Info.Name)-Length(ImagesExt)));
    Until FindNext(info) <> 0
  end else ListBox1.Items.Add(rsDirVacio);
  FindClose(Info);

  TXTDBCategoria := TTXTDB.create(ArchivoTXTDBCategoria);
  TXTDBCategoria.ReadTXTDB;

  for Index := 1 to TXTDBCategoria.RecordCount do
  begin
    TXTDBCategoria.RecordIndex := Index;
    Combobox1.Items.Add(TXTDBCategoria.RecordData[fnPRODUCTO]);
  end;

  Combobox1.Text := rsSelection;

  TXTDBCategoria.Free;

  Image2.Picture.LoadFromFile(ImagesDir+ImageUbi+ImagesExt);

  LabelNP1.Caption := '';
  LabelNP2.Caption := '';
  LabelNP3.Caption := '';
end;

procedure TForm7.Form7SHOW(Sender: TObject);
var
  Index: Integer;

begin
{$IFDEF FPC}
{$ELSE}
  PageControl1.ActivePageIndex := 0;
{$ENDIF}

// ComboBox2,3,4 (Proveedores)
  Combobox2.Clear;
  Combobox3.Clear;
  Combobox4.Clear;

  TXTDBClientes := TTXTDB.create(ArchivoTXTDBClientes);
  With TXTDBClientes do
  begin
  ReadTXTDB;
  for Index := 1 to RecordCount do
  begin
    RecordIndex := Index;
    if RecordData[fnCATEGORIA] = 'Proveedor' then
      Combobox2.Items.Add(RecordData[fnCODIGO]);
  end;
    Free;
  end;

  Combobox3.Items := Combobox2.Items;
  Combobox4.Items := Combobox2.Items;

  if (Caption = rsModificar) Or (Caption = rsVer) then
  begin
  EditCodigo.Enabled := False;
  TXTDBInventario := TTXTDB.create(ArchivoTXTDBInventario);
  With TXTDBInventario do
   begin
     ReadTXTDB;
     RecordIndex := Tag;
     EditCodigo.Text := RecordData[fnCODIGO];
     EditDesc.Text := RecordData[fnDESC];
     EditCosto.Text := RecordData[fnCOSTO];
     EditUtil1.Text := RecordData[fnINCREMENTO1];
     EditUtil2.Text := RecordData[fnINCREMENTO2];
     EditPrecio1.Text := RecordData[fnPRECIO1];
     EditPrecio2.Text := RecordData[fnPRECIO2];
     EditCod_Fab.Text := RecordData[fnCOD_FAB];
     RadioGroup1.Items.Text := '';
     RadioGroup1.Items.Text := rsFisico+#13#10+rsServicio;
     RadioGroup1.ItemIndex := RecordDataI[fnPROD_TIPO];

     {ToggleBox2.Checked := False; ToggleBox2.Checked := True; // Queee cosa..
     ToggleBox1.Checked := False; ToggleBox1.Checked := True;}
     CheckBox2.Checked := Boolean(RecordDataI[fnFACT_SIN_EX]);

     Edit10.Text := RecordData[fnCANT_ALM];
     Edit11.Text := RecordData[fnCANT_MINI];
     CheckBox1.Checked := Boolean(RecordDataI[fnAVISAR_F_E]);
     EditFE.Text := RecordData[fnF_EXP];
     EditC1.Text := RecordData[fnCOMENTARIO1];
     EditC2.Text := RecordData[fnCOMENTARIO2];
     EditC3.Text := RecordData[fnCOMENTARIO3];
     EditUbi.Text := RecordData[fnUBICACION];
     Points[1].X := RecordDataI[fnUBI1_X];
     Points[1].Y := RecordDataI[fnUBI1_Y];
     Points[2].X := RecordDataI[fnUBI2_X];
     Points[2].Y := RecordDataI[fnUBI2_Y];
     Points[3].X := RecordDataI[fnUBI3_X];
     Points[3].Y := RecordDataI[fnUBI3_Y];
     PointCount := 3; ReDrawPoints;

     Combobox1.Text := RecordData[fnCOD_CATEG];

     Index := Combobox2.Items.IndexOf(RecordData[fnPROVEEDOR1]);
     if Index > -1 then
     begin
       Combobox2.ItemIndex := Index;
       Combobox2.Text := RecordData[fnPROVEEDOR1];
     end else
       Combobox2.Text := rsSelection;

     Index := Combobox3.Items.IndexOf(RecordData[fnPROVEEDOR2]);
     if Index > -1 then
     begin
       Combobox3.ItemIndex := Index;
       Combobox3.Text := RecordData[fnPROVEEDOR2];
     end else
       Combobox3.Text := rsSelection;

     Index := Combobox4.Items.IndexOf(RecordData[fnPROVEEDOR3]);
     if Index > -1 then
     begin
       Combobox4.ItemIndex := Index;
       Combobox4.Text := RecordData[fnPROVEEDOR3];
     end else
       Combobox4.Text := rsSelection;

     UpdateLabelNP(Combobox2.Tag);
     UpdateLabelNP(Combobox3.Tag);
     UpdateLabelNP(Combobox4.Tag);
       
     Index := Listbox1.Items.IndexOf(RecordData[fnIMAGEN]);
     if Index > -1 then
      Listbox1.ItemIndex := Index else
      Listbox1.ItemIndex := 0;

     UpDateImage1; 
     Free;
   end;
  end else

  if Caption = rsNuevo then
  begin
  EditCodigo.Enabled := True;
  EditCodigo.Text := cCODE;
  EditDesc.Text := '';
  EditCosto.Text := '';
  EditUtil1.Text := '';
  EditUtil2.Text := '';
  EditPrecio1.Text := '';
  EditPrecio2.Text := '';
  EditCod_Fab.Text := '';

  RadioGroup1.Items.Text := '';
  RadioGroup1.Items.Text := rsFisico+#13#10+rsServicio;
  RadioGroup1.ItemIndex := 0;

  {CheckBox2.Checked := False; ToggleBox2.Checked := True; // Queee cosa..
  ToggleBox1.Checked := False; ToggleBox1.Checked := True;}
  CheckBox2.Checked := False;
  CheckBox1.Checked := False;
  
  Edit10.Text := '';
  Edit11.Text := '';
  EditFE.Text := '';
  EditC1.Text := '';
  EditC2.Text := '';
  EditC3.Text := '';
  EditUbi.Text := '';
  Points[1].X := 0;
  Points[1].Y := 0;
  Points[2].X := 0;
  Points[2].Y := 0;
  Points[3].X := 0;
  Points[3].Y := 0; PointCount := 0;

  Combobox1.Text := rsSelection;

  Combobox2.Text := rsSelection;
  Combobox3.Text := rsSelection;
  Combobox4.Text := rsSelection;

  UpdateLabelNP(Combobox2.Tag);
  UpdateLabelNP(Combobox3.Tag);
  UpdateLabelNP(Combobox4.Tag);

  Listbox1.ItemIndex := 0;
  end;

  if Caption = rsVer then EnabledControls(False) else EnabledControls(True);
end;

procedure TForm7.Button2CLICK(Sender: TObject);
var
  RecordDeleted: Boolean;

begin
  if ComboBox1.ItemIndex < 0 then MSGInfo(rsNoSelected)
  else
    if MSGConfirmationYN(rsDeleteReg) = mrYes then
    begin
      TXTDBCategoria := TTXTDB.create(ArchivoTXTDBCategoria);
      TXTDBCategoria.ReadTXTDB;
      TXTDBCategoria.RecordIndex := ComboBox1.ItemIndex +1;
      RecordDeleted := TXTDBCategoria.RecordDelete;
      TXTDBCategoria.Free;
      if RecordDeleted then ComboBox1.Items.Delete(ComboBox1.ItemIndex)
      else MSGError(rsNoDeleted);
    end;
end;

procedure TForm7.Combobox2CHANGE(Sender: TObject);
begin
  UpdateLabelNP((Sender as TCombobox).Tag);
end;

procedure TForm7.Edit10CHANGE(Sender: TObject);
begin
  ValidateText(Sender);
end;

procedure TForm7.Edit11CHANGE(Sender: TObject);
begin
  ValidateText(Sender);
end;

procedure TForm7.EditCodigoEXIT(Sender: TObject);
begin
  if EditCodigo.Text = '' then EditCodigo.Text := cCODE;
end;

procedure TForm7.EditCodigoKEYPRESS(Sender: TObject; var Key: Char);
begin
  ValidateKey(Key)
end;

procedure TForm7.EditCostoCHANGE(Sender: TObject);
begin
  ValidateText(Sender);

  EditUtil1CHANGE(EditUtil1);
  EditUtil2CHANGE(EditUtil2);
end;

procedure TForm7.EditFEEXIT(Sender: TObject);
begin
  EditFE.Text := Trim(EditFE.Text);
  if EditFE.Text <> '' then
  Try
    EditFE.Text := DateToStr(StrToDate(EditFE.Text));
  Except
    On EConvertError do
    begin
      EditFE.Text := DateToStr(Date);
      MSGError(rsInvalidDate);
    end;
  end;
end;

procedure TForm7.EditPrecio1CHANGE(Sender: TObject);
begin
  ValidateText(Sender);
end;

procedure TForm7.EditPrecio2CHANGE(Sender: TObject);
begin
  ValidateText(Sender);
end;

procedure TForm7.EditUtil1CHANGE(Sender: TObject);
var
  s: string;
  Costo, Precio1: Real;

begin
  ValidateText(Sender);

  Costo := StrReal(EditCosto.Text);
  Precio1 := Costo + (Costo * (StrReal((Sender as TEdit).Text)/100));
  Str(Precio1:14:2, s);
  EditPrecio1.Text:= s;
end;

procedure TForm7.EditUtil2CHANGE(Sender: TObject);
var
  s: string;
  Costo, Precio2: Real;

begin
  ValidateText(Sender);

  Costo := StrReal(EditCosto.Text);
  Precio2 := Costo + (Costo * (StrReal((Sender as TEdit).Text)/100));
  Str(Precio2:14:2, s);
  EditPrecio2.Text:= s;
end;

procedure TForm7.Button1CLICK(Sender: TObject);
begin
  TXTDBCategoria := TTXTDB.create(ArchivoTXTDBCategoria);
  With TXTDBCategoria do
  begin
    ReadTXTDB;
    if DataExist(fnPRODUCTO, ComboBox1.Text) then
      MSGError(rsExist+ComboBox1.Text) else
    begin
      RecordAdd;
      RecordData[fnPRODUCTO] := ComboBox1.Text;
      ComboBox1.Items.Add(ComboBox1.Text);
      WriteTXTDB;
      MSGInfo(rsAnadido);
    end;
    Free;
  end;
end;

procedure TForm7.Bitbtn1CLICK(Sender: TObject);
begin
  if (Caption = rsNuevo) Or (Caption = rsModificar) then
  begin
    TXTDBInventario := TTXTDB.create(ArchivoTXTDBInventario);
    With TXTDBInventario do
     begin
       ReadTXTDB;
       if Caption = rsNuevo then
       begin

         if DataExist(fnCODIGO, EditCodigo.Text) then
         begin
           MSGInfo('El Cdigo ya existe.');
           Free;
           ModalResult := mrNone;
           Exit
         end;

         RecordAdd;
         RecordData[fnCODIGO] := EditCodigo.Text
       end else
       RecordIndex := Tag;      //Continua aqui
       RecordData[fnDESC] := EditDesc.Text;
       RecordData[fnCOSTO] := EditCosto.Text;
       RecordData[fnINCREMENTO1] := EditUtil1.Text;
       RecordData[fnINCREMENTO2] := EditUtil2.Text;
       RecordData[fnPRECIO1] := EditPrecio1.Text;
       RecordData[fnPRECIO2] := EditPrecio2.Text;
       RecordData[fnCOD_FAB] := EditCod_Fab.Text;
       RecordDataI[fnPROD_TIPO] := RadioGroup1.ItemIndex;
       RecordDataI[fnFACT_SIN_EX] := Integer(CheckBox2.Checked);
       RecordData[fnCANT_ALM] := Edit10.Text;
       RecordData[fnCANT_MINI] := Edit11.Text;
       RecordDataI[fnAVISAR_F_E] := Integer(CheckBox1.Checked);
       RecordData[fnF_EXP] := EditFE.Text;
       RecordData[fnCOMENTARIO1] := EditC1.Text;
       RecordData[fnCOMENTARIO2] := EditC2.Text;
       RecordData[fnCOMENTARIO3] := EditC3.Text;
       RecordData[fnUBICACION] := EditUbi.Text;
       RecordDataI[fnUBI1_X] := Points[1].X;
       RecordDataI[fnUBI1_Y] := Points[1].Y;
       RecordDataI[fnUBI2_X] := Points[2].X;
       RecordDataI[fnUBI2_Y] := Points[2].Y;
       RecordDataI[fnUBI3_X] := Points[3].X;
       RecordDataI[fnUBI3_Y] := Points[3].Y;// PointCount := 3;
       RecordData[fnCOD_CATEG] := Combobox1.Text;
       RecordData[fnPROVEEDOR1] := Combobox2.Text;
       RecordData[fnPROVEEDOR2] := Combobox3.Text;
       RecordData[fnPROVEEDOR3] := Combobox4.Text;
       if Listbox1.ItemIndex > -1 then
         RecordData[fnIMAGEN] := Listbox1.Items[Listbox1.ItemIndex]
       else
         RecordData[fnIMAGEN] := 'Sin imagen';
{      Try
        RecordData[fnIMAGEN] := Listbox1.Items[Listbox1.ItemIndex]; // De prueba
       Except
        On ERangeError do RecordData[fnIMAGEN] := 'Sin imagen';
       end;}
       WriteTXTDB;
       Free;
     end;
   end;
end;

procedure TForm7.Listbox1Click(Sender: TObject);
begin
  UpDateImage1;
end;

procedure TForm7.PaintBox1Paint(Sender: TObject);
begin
  ReDrawPoints;
end;

procedure TForm7.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
  begin
{$IFDEF FPC}
    Image2.Refresh;
{$ELSE}
    PaintBox1.Color := Not PaintBox1.Color;
{$ENDIF}
    Points[1].X := 0; Points[1].Y := 0;
    Points[2].X := 0; Points[2].Y := 0;
    Points[3].X := 0; Points[3].Y := 0;
    PointCount := 0;
  end;

  //if Button = mbLeft then ReDrawPoints;

  if (Button = mbLeft) And (PointCount < 3) then
  begin
    PutIndicator(X, Y);
    Inc(PointCount);
    Points[PointCount].X := X; Points[PointCount].Y := Y;
  end;
end;

procedure TForm7.Bitbtn3Click(Sender: TObject);
begin
  AyudaHTML(Con_CrearP);
end;

initialization
{$IFDEF FPC}
  {$I productos.lrs}
{$ELSE}
  {$R *.dfm}
{$ENDIF}

end.

