{ Copyright (C) 09/09/2004 00:00, Luis R. Hilario B. <info@luisdigital.com>

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}

unit util;

{$IFDEF FPC}
 {$mode objfpc}
{$ENDIF}
{$H+}

interface

uses
  Classes, SysUtils, Graphics;

procedure ValidateKey(var Key: Char);
function SystemBrowser(const Opt: String): String;
procedure AyudaHTML(const ConTexto: string);
{$IFDEF FPC}
function CargarRecImag(const Recurso: string): TPixmap;
function CargarArcImag(const NombreArchivo: string): TPixmap;
{$ELSE}
function ExecuteFile(const FileName, Parameters: string): Integer;
{$ENDIF}
procedure MSGInfo(MSG: String);
procedure MSGError(MSG: String);
function MSGConfirmationYN(MSG: String): Integer;
function StrNumStr(Text: String; Int,Dec: Integer):String;
function StrReal(Text: String):Real;
function NumStr(N: Real): String; overload;
function NumStr(N: Integer): String; overload;
function ValidateFormat(var Text: string; const Int,Dec: Integer): string;
procedure ValidateText(Sender: TObject);
procedure ProgramReset;


implementation

uses
 TXTDB, Dialogs, StdCtrls,
{$IFDEF FPC}
 Process,
{$ELSE}
 Windows, ShellApi,
{$ENDIF}
 klintonstrconst;

procedure ValidateKey(var Key: Char);
begin
  if Not(Key In[Char(VK_BACK),'0'..'9', 'a'..'z', 'A'..'Z', '', '',
                '-', '_', '+', '*', '/', '(', ')']) then Key := #0;
end;

function SystemBrowser(const Opt: String): String;
var
  Browser,
  FullPath,
  Name,
  Para: String;

begin
  FullPath := '';
  Name := '';
  Para := '';
  Browser := GetEnvironmentVariable('BROWSER');
  Name := Copy(Browser, 1, Pos(' ', Browser +' ')-1);
  if Length(Name) <> Length(Browser) then
   Para := Copy(Browser, Pos(' ', Browser)+1, Length(Browser));

  FullPath := FileSearch(Name, GetEnvironmentVariable('PATH'));
  if Opt = 'FullPath' then Result := FullPath else
   if Opt = 'Name' then Result := Name else
    if Opt = 'Para' then Result := Para else
     Result := '';
end;

procedure AyudaHTML(const ConTexto: string);
var
{$IFDEF FPC}
  Process1: TProcess;
{$ELSE}
  Parametros: String;
{$ENDIF}
  Ruta: String;

begin
{$IFDEF FPC}
  Process1 := TProcess.create(nil);
  With TTXTDB.create(ArchivoTXTDBConf) do
  begin
   ReadTXTDB;
   Process1.CommandLine := RecordData[fnNAVEGADOR] + ' '+
                           RecordData[fnPARAMETROS] + ' '+
                           GetCurrentDir+ '/'+ArchivoAyuda;
   Free;
  end;
   if ConTexto <> '' then Process1.CommandLine := Process1.CommandLine +
                                                  ConTexto;
   Process1.Execute;
   Process1.Free;
{$ELSE}
{  CurrentDir := GetCurrentDir;
  repeat
    Index := Pos('\', CurrentDir);
    Delete(CurrentDir, Index, 1);
    Insert('/', CurrentDir, Index);
  until Index = 0;}

  With TTXTDB.create(ArchivoTXTDBConf) do
  begin
   ReadTXTDB;
   Ruta := '"file:///'+GetCurrentDir+ '/'+ArchivoAyuda + ConTexto + '"';
   Parametros := RecordData[fnPARAMETROS] + ' ' +Ruta;
   if RecordData[fnNAVEGADOR] = cPredeterminado then
     ExecuteFile(Ruta, '')
   else
     ExecuteFile(RecordData[fnNAVEGADOR], Parametros);

   Free;
  end;
{$ENDIF}
end;

{$IFDEF FPC}
function CargarRecImag(const Recurso: string): TPixmap;
begin
  Result := TPixmap.Create;
  Result.LoadFromLazarusResource(Recurso);
end;

function CargarArcImag(const NombreArchivo: string): TPixmap;
var
  S: TFileStream;

begin
  S := TFileStream.Create(NombreArchivo, fmOpenRead);
  try
    Result := TPixmap.Create;
//    Result.TransparentColor := $90A050;
    Result.LoadFromStream(S);
  finally
    S.Free;
  end;
end;

{$ELSE}
function ExecuteFile(const FileName, Parameters: string): Integer;
begin
//Application.MainForm.Handle
{function ShellExecute(hWnd: HWND; Operation, FileName, Parameters,
  Directory: PChar; ShowCmd: Integer): HINST; stdcall;}
  Result := ShellExecute(0, nil, PChar(FileName), PChar(Parameters),
                         nil, SW_SHOWNORMAL);
end;
{$ENDIF}
procedure MSGInfo(MSG: String);
begin
  MessageDlg({$IFDEF FPC}rsInformacion,{$ENDIF} MSG, mtInformation, [mbOK], 0);
end;

procedure MSGError(MSG: String);
begin
  MessageDlg(MSG, mtError, [mbOK], 0);
end;

function MSGConfirmationYN(MSG: String): Integer;
begin
  Result := MessageDlg({$IFDEF FPC}rsConfirmacion, {$ENDIF}MSG,
            mtConfirmation, [mbYes, mbNo], 0)
end;

function StrNumStr(Text: String; Int,Dec: Integer):String;
var
  S: String;
  R: Real;
  Code: Integer;

begin
 Val(Text, R, Code);
  if Code <> 0 then R := 0;

  Str(R:Int:Dec, S);
  Result := S;
end;

function StrReal(Text: String):Real;
var
  R: Real;
  Code: Integer;

begin
 Val(Text, R, Code);
  if Code <> 0 then R := 0;

  Result := R;
end;

function NumStr(N: Real): String;
begin
  Str(N, Result)
end;

function NumStr(N: Integer): String;
begin
  Str(N, Result)
end;

function ValidateFormat(var Text: string; const Int,Dec: Integer): string;
var
  R: Real;
  Code,
  MaxLength: Integer;

begin
  Result := '';
  MaxLength := Int+1+Dec;
  Val(Text, R, Code);
  if Code = 0 then
  begin
  if Pos('.', Text) <> 0 then
   if (Length(Text) - Pos('.', Text)) > 2 then Code := 101;
  if R < 0 then
  begin
    Code := 102;
    R := Abs(R)
  end;
  if Length(Format('%*.*f', [Int, Dec, R])) > MaxLength then Code := 103;
  end;

  if Code <> 0 then
  begin
    Case Code of
     101: Result := 'Slo dos decimales';
     102: Result := 'Slo Cantidades positivas';
     103: begin
           R := 0;
           Result := 'Cantidad excede largo, mx.'+ Format('%2d',
                      [MaxLength])+ ' caracteres.';
          end;
    else
     R := 0;
    end;
     Text := Format('%*.*f', [Int, Dec, R]);
  end;
end;

procedure ValidateText(Sender: TObject);
var
  Resultado, Texto: String;

begin
  Texto := (Sender as TEdit).Text;
  Resultado := ValidateFormat(Texto, (Sender as TEdit).MaxLength-3, 2);

  if Resultado <> '' then MSGError(Resultado);
  (Sender as TEdit).Text := Texto;
end;

procedure ProgramReset;
begin
  SetCurrentDir(ExtractFilePath(ParamStr(0)));
  DateSeparator := '-';
  ShortDateFormat := 'dd/mm/yyyy';
end;

initialization
  ProgramReset;

end.

